

#################################################################
lmeRob=function(fixed, data, random,...){
	#@ 22/11/06
	#@ - same syntax as in the nlme library
	#@   but:
	#@   - no interaction bw indep. unit and a between factor
	#@   - random can't be a list
	#@   - random effects are independant
	#@ - need a "print.lmeRob" function
	#@ - use ... to modify default of cov.ctbs
	mc=match.call()
	ltc=lme.to.ctbs(mc)
	RES=cov.cbs.mm.lrt(ltc,...)
	class(RES)="lmeRob"
	invisible(RES)
	}
#################################################################





#################################################################
lme.to.ctbs=function(mc){
	#@ 17/12/06 (dlc)
	#@ - include new warnings and stop
	#@ - no problem with "data" anymore
	#@ - change slightly the output
	#@   - small matrices (for ctbs) now called y, x, and z (in yxz)
	#@   - new big matrices for the predictions and residuals (in YXZ)
	#@   - dim contains some dim of the fix, random, ...
	#
	# USEFUL FUNCTIONS
	#
	# (Bates/lme4)
	findbars <- function(term)
		{
		    if (is.name(term) || !is.language(term)) return(NULL)
		    if (term[[1]] == as.name("(")) return(findbars(term[[2]]))
		    if (!is.call(term)) stop("term must be of class call")
		    if (term[[1]] == as.name('|')) return(term)
		    if (length(term) == 2) return(findbars(term[[2]]))
		    c(findbars(term[[2]]), findbars(term[[3]]))
		}
	# (Bates/lme4)
	slashTerms <- function(x) {
	    if (!("/" %in% all.names(x))) return(x)
	    if (x[[1]] != as.name("/"))
		stop("unparseable formula for grouping factor")
	    list(slashTerms(x[[2]]), slashTerms(x[[3]]))
	}
	# (Bates/lme4)
	makeInteraction <- function(x) {
	    if (length(x) < 2) return(x)
	    trm1 <- makeInteraction(x[[1]])
	    trm11 <- if(is.list(trm1)) trm1[[1]] else trm1
	    list(substitute(foo:bar, list(foo=x[[2]], bar = trm11)), trm1)
	}
	# (Bates/lme4)
	expandSlash <- function(bb) {
	    if (!is.list(bb)) return(expandSlash(list(bb)))
	    unlist(lapply(bb, function(x) {
		if (length(x) > 2 && is.list(trms <- slashTerms(x[[3]])))
		    return(lapply(unlist(makeInteraction(trms)),
				  function(trm) substitute(foo|bar,
							   list(foo = x[[2]],
								bar = trm))))
	    x
	    }))
	}
	#
	# CHANGE THE MATCH.CALL (if different order given)
	#
	m <- match(c("fixed","data","random"),
		   names(mc), 0)
	mc <- mc[c(1, m)]
	#
	# GET THE DATA / FIND THE GROUPING VARIABLE / ORDER THE DATASET / SIZE
	#
	data=get(as.character(mc[[3]]))
	re=mc[[4]]
	if(re[[1]]=="list"){stop("Stop:\n-> The random argument of lmeRob can't be a list\n")}
	re0= expandSlash(findbars(re))
	names(re0)=unlist(lapply(re0, function(x) deparse(x[[3]])))
	lre0=length(re0)
	gv=names(re0)[lre0]
	# the order of the dataset is paramount (as Z is the same for every unit)
	resp=all.vars(mc[[2]][[2]])
	allvar=dimnames(data)[[2]]
	allvar=allvar[allvar!=resp&allvar!=gv]
	for(i in 1:length(allvar)){data=data[order(data[,allvar[i]]),]}
	data0=data0b=data[order(data[,gv]),]
	datan=split(data0,as.numeric(data0[,gv]))
	# n = number of indep unit / m = number of obs per unit / N = overall number of obs
	tgv=table(data0[,gv]);n=length(tgv)
	N=dim(data0)[1]
	m=N/n;if(sum(tgv==m)!=n){stop("Stop:\n-> Need balanced data\n")}
	#
	# FIXED EFFECTS
	#
	mf=mc[1]
	mf$formula=mc[[2]];mf$data=data0
	mf[[1]]=as.name("model.frame")
	mf=eval(mf,parent.frame(2))
	mt=attr(mf,"terms")
	# Build Y (matrix) and X (list of matrices)
	Y=matrix(model.response(mf, "numeric"),ncol=1)
	y=matrix(Y,ncol=m,nrow=n,byrow=T)
	X=model.matrix(mt,mf,contrasts)
	x=as.list(rep(NA,n))
	for(i in 1:n){x[[i]]=X[data0[,gv]==names(tgv[i]),]}
	# Change the contrast of X for the robust multivariate test:
	# (need only sum contrats for the X matrix)
	if(length(allvar)>1){factallvar = sapply(data0b[,allvar],class)=="factor"
		}else{factallvar = class(data0b[,allvar])=="factor"}
	factallvar=seq(1,length(factallvar))[factallvar]
	for(fav in 1:length(factallvar)){contrasts(data0b[,allvar[factallvar[fav]]])="contr.sum"}
	mf2=mc[1]
	mf2$formula=mc[[2]];mf2$data=data0b
	mf2[[1]]=as.name("model.frame")
	mf2=eval(mf2,parent.frame(2))
	mt2=attr(mf2,"terms")
	X2=model.matrix(mt2,mf2,contrasts)
	x2=as.list(rep(NA,n))
	for(i in 1:n){x2[[i]]=X2[data0[,gv]==names(tgv[i]),]}
	#
	# RANDOM EFFECTS
	#
	# case of nested structure...
	if(lre0>1){for(i in 1:lre0){names(re0)[i]=all.vars(re0[[i]])[1]}}
	re0=re0[lre0:1]
	# God save the Queen... for every level
	Zf=NULL
	for(l in 1:lre0){
		rel=as.list(re0[[l]])
		gel=as.character(pairlist(rel[[3]]))
		felv=all.vars(rel[[2]]);n.felv=length(felv)
		felft=terms(as.formula(paste("~",as.character(re0[[1]])[2])))
		# test if a fe is a between subject factor...
		if(n.felv>0){
		for(f in 1:n.felv){
			if(sum(unlist(lapply(datan,function(x,vect){sum(x[,felv[f]]==data0[1:m,felv[f]])==m})))!=n){
				cat(paste("Warning:\n->",felv[f],"seems to be a between factor: interaction with",gel,"not allowed\n"))
			}else{felv[f]=NA}
			}
		# delete interaction with between factors
		felv=felv[!is.na(felv)];n.felv=length(felv)
		fel=attr(felft,"factors")
		if(n.felv>0){for(f in 1:n.felv){fel=fel[,fel[felv[f],]==0,drop=F]}}
		fel=paste(dimnames(fel)[[2]],gel,sep=":")
		}else{fel=NULL}
		# add the wished formula in a list
		Zf=list(Zf,lapply(as.list(paste("~",c(gel,fel),"-1")),
				  as.formula))
		}
	# Build the Z and z matrices
	r=length(unlist(Zf))+1
	Z=as.list(rep(NA,r))
	Z[[r]]=diag(N);dimnames(Z[[r]])[[2]]=as.character(1:N)
	Z[-r]=lapply(unlist(Zf),
			function(x)model.matrix(eval(x),data0)
			)
	if(sum(sapply(Z[-r],function(x)dim(x)[2]==N)))stop("Stop:\n-> Too many random effects\n")
	z=lapply(Z,function(x)x[1:m,1:(dim(x)[2]/n),drop=F])
	dims=list(N=N,n=n,m=m,level=lre0,r=r,qv=sapply(Z,function(x)dim(x)[2]),gv=gv,
		  idqv=lapply(Z,function(x)dimnames(x)[[2]]),
		  idZ=c(sapply(unlist(Zf),function(x)as.character(pairlist(x[[2]][[2]]))),"Residuals"),
		  idi=as.vector(data0[,gv])
		  )
	names(dims$idqv)=dims$idZ
	# inf for scatterplot
	data1=data0[1:n,!(dimnames(data0)[[2]]==resp|dimnames(data0)[[2]]==gv)]
	if(is.data.frame(data1)){
	for(i in 1:(dim(data1)[2])){data1[,i]=as.character(data1[,i])}
	for(i in 1:n){data1[i,1]=paste(data1[i,],collapse="\n")}
	names.scat=as.vector(data1[,1])
	}else{names.scat=NA}
	# output
	invisible(list(yxz=list(y=y,x=x,z=z,x2=x2),YXZ=list(Y=Y,X=X,Z=Z,X2=X2),
	               mc=mc,mt=mt,mf=mf,names.scat=names.scat,dim=dims))
	}
#################################################################




################################################################################
fitted.lmeRob=function(output,level=1:2){
	# list de longueur 2:
	# 1 niveau : fitted = EY
	# 2 niveau : fitted = Y-residuals
	#            (donc avec estimations des random effects)
	ltc=output$ltc
	r=ltc$dim$r-1
	# estimation
	Population=ltc$YXZ$X%*%output$alpha
	ranefw=ranef.lmeRob(output)
	ranefw=ranefw$uhat
	for(v in 1:r){ranefw[[v]]=ltc$YXZ$Z[[v]]%*%as.matrix(ranefw[[v]])}
	Subject=Population
	for(v in 1:r){Subject=Subject+ranefw[[v]]}
	# output
	matFit=cbind(Population,Subject)
	dimnames(matFit)[[2]]=cbind("Population","Subject")
	class(dimnames)="fitlmeRob"
	matFit[,level]
	}
################################################################################




################################################################################
residuals.lmeRob=function(output,level=1:2){
  # list de longueur 2:
	# 1 niveau : Y-EY (population)
	# 2 niveau : estimation des effets aleatoires residus
  matxFit=fitted.lmeRob(output,level=1:2)
  ranefresid=ranef.lmeRob(output)
  ltc=output$ltc
  matResid=cbind(ranefresid$popresid,ranefresid$subjresid)
	dimnames(matResid)[[2]]=cbind("Population","Subject")
  #opt
	opt=list(matResid=matResid[,level],matxFit=matxFit[,level],level=level,
	         n=output$ltc$dim$n,m=output$ltc$dim$m,w=output$w,idi=ltc$dim$idi)
	class(opt)="residlmeRob"
	invisible(opt)
	}
	

print.residlmeRob=function(opt){
	print(opt$matResid)
	}
	
 


plot.residlmeRob=function(opt,id.n=5,cex=.75){
	level=opt$level
	nl=length(level)
	# outliers identification
	out=as.vector(kronecker(diag(opt$n),matrix(1,ncol=1,nrow=opt$m))%*%matrix(opt$w!=1,ncol=1)==1)
	add.label <- function(x, y, id.n = id.n){
		if(id.n) {
			n <- length(y)
			oy <- order(abs(y))
			which <- oy[(n - id.n + 1):n]
			text(x[which], y[which], opt$idi[which], adj = 0,pos=3,col="black",cex=cex)
		}
	}
	# plot
	x11()
	par(mfcol=c(1,nl),col.main=1,omi=c(0,0,1,0))
	for(v in 1:nl){
		posl=level[v]
		plot(opt$matxFit[,posl],opt$matResid[,posl],main=dimnames(opt$matResid)[[2]][posl],
		     xlab="Fitted values",ylab="residuals",type="n")
		points(opt$matxFit[,posl][!out],opt$matResid[,posl][!out],pch=21)
		points(opt$matxFit[,posl][out], opt$matResid[,posl][out],pch=21)
		add.label(opt$matxFit[,posl],opt$matResid[,posl], id.n = id.n)
		abline(h=0,col="dark gray",lty=3)
		#if(opt$type=="p")abline(h=c(-1.96,1.96),col="dark gray",lty=2)
		}
	mtext("Residual vs Fitted",side=3,col=4,cex=1.5,outer=T)
	}
################################################################################




################################################################################
ranef.lmeRob=function(output){
	# list de longueur r (position r = residus)
	# info
	r=output$ltc$dim$r
	r1=output$ltc$dim$r-1
  qv=output$ltc$dim$qv[1:r1];sqv=sum(qv)
  N=output$ltc$dim$N
  c1=output$c1
  Zmat=output$ltc$YXZ$Z
	# prepare
	D=matrix(0,ncol=sqv,nrow=sqv)
  diag(D)=rep(output$s[1:r1],times=qv)
  Z=NULL
  Z1=NULL
	for(v in 1:r){Z=cbind(Z,output$ltc$YXZ$Z[[v]])}
	for(v in 1:r1){Z1=cbind(Z1,output$ltc$YXZ$Z[[v]])}
 
  V=array(0,dim=c(N,N,(r+1)))
  for(v in 1:(r)){V[,,v]=output$s[v]*(output$ltc$YXZ$Z[[v]]%*%t(output$ltc$YXZ$Z[[v]]))}
  V=apply(V[,,1:(r)],1:2,sum)
  Y=output$ltc$YXZ$Y
	EY=output$ltc$YXZ$X%*%output$alpha
	# calcule
	cst.ranef=(Norm.TM(c1)[2]-((4/c1^2)*Norm.TM(c1)[3])+((6/c1^4)*Norm.TM(c1)[4])-((4/c1^6)*Norm.TM(c1)[5])
            +((1/c1^8)*Norm.TM(c1)[6]))^(-0.5)
  uhat=lapply(split(cst.ranef*(D%*%t(Z1)%*%denman.beavers(V)$sqrt.inv%*%biwt.psi(denman.beavers(V)$sqrt.inv%*%(Y-EY),k=c1)),
       rep(1:r1,times=qv)), function(x)as.data.frame(matrix(x,ncol=1)))
  names(uhat)=output$ltc$dim$idZ[1:r1]
  popresid=Y-EY
  negsigma=all(output$s>0) 
  if(negsigma==TRUE) {
  for(i in 1:r1){
      dimnames(uhat[[i]])=list(output$ltc$dim$idqv[[i]],"predictions") 
      m=nrow(Zmat[[i]])
      p=ncol(Zmat[[i]])
      var1=Zmat[[i]][1:m,1:p]
      var2=as.vector(uhat[[i]]$predictions)*sqrt(output$s[i])
      subjresid=popresid-var1%*%var2
  }      }
  else {
   for(i in 1:r1){
      dimnames(uhat[[i]])=list(output$ltc$dim$idqv[[i]],"predictions") 
      m=nrow(Zmat[[i]])
      p=ncol(Zmat[[i]])
      var1=Zmat[[i]][1:m,1:p]
      var2=as.vector(uhat[[i]]$predictions)
      subjresid=popresid-var1%*%var2
  }}
  sol=list(uhat=uhat,popresid=popresid,subjresid=subjresid)                                                           
  class(sol)="raneflmeRob"
  sol
 }


################################################################################
plot.raneflmeRob=function(objranef){
	# list de longueur r (position r = residus)
	# info
	r=length(objranef$uhat)
	# x11
	par(mfcol=c(2,r),col.main=1,omi=c(0,0,1,0))
	for(v in 1:r){
		boxplot(objranef$uhat[[v]],col="light gray",main=names(objranef$uhat)[v])
		abline(h=0,col="red")
		qqnorm(objranef$uhat[[v]][,1],main=" ")
		}
	mtext("Random Effects",side=3,col=4,cex=1.5,outer=T)
	}
################################################################################





################################################################################
plot.lmeRob <-function(output, id.n = 5){
	center <- output$alpha
	Rmal <- output$dis
	ltc <- output$ltc
	gv=ltc$dim$gv
	z <- length(Rmal)
	p <- length(center)
	out = Rmal>=qchisq(0.975, p)
	seq1z=1:z
  mle <- cov.mle(ltc,bdp = 0.5, arp = 0.01, t1 = NULL, mats = NULL,
	eps = 10e-5, maxiter = 1000)
 	Mmal <- mle$dis
	label=sapply(ltc$dim$idqv[[gv]],function(x)substr(x,nchar(gv)+1,nchar(x)))
 	add.label <- function(x, y, id.n = id.n){
		if(id.n) {
			n <- length(y)
			oy <- order(abs(y))
			which <- oy[(n - id.n + 1):n]
			text(x[which], y[which], label[which], adj = 0,pos=3,col="black")
		}
	}
  # open window
	x11()
	par(mfcol=c(1,3),col.main=1,omi=c(0,0,1,0))
	# plot 1
	plot(seq1z, Rmal, ylab = "Distances", xlab = "Index",type="n",main="Robust (MM-BS)")
	points(seq1z[!out], Rmal[!out],pch=21,bg="green")
	points(seq1z[out], Rmal[out],pch=21,bg="red")
	add.label(seq1z, Rmal, id.n = id.n)
	abline(qchisq(0.975, p), 0, lty = 2,col="dark gray")
	title()
	# plot 2
	plot(seq1z, Mmal, ylab = "Distances", xlab = "Index",type="n",main="Classic")
	points(seq1z[!out], Mmal[!out],pch=21,bg="green")
	points(seq1z[out], Mmal[out],pch=21,bg="red")
	add.label(seq1z, Mmal, id.n = id.n)
	abline(qchisq(0.975, p), 0, lty = 2,col="dark gray")
	# plot 3
	plot(Mmal, Rmal, ylab = "Robust", xlab = "Classic",type="n",main="Comparison")
	points(Mmal[!out], Rmal[!out],pch=21,bg="green")
	points(Mmal[out], Rmal[out],pch=21,bg="red")
	add.label(Mmal, Rmal, id.n = id.n)
	abline(0, 1, lty = 3,col="dark gray")
	abline(h=qchisq(0.975, p),lty = 2,col="dark gray")
	abline(v=qchisq(0.975, p),lty = 2,col="dark gray")
	mtext("Mahalanobis Distances",side=3,col=4,cex=1.5,outer=T)
	# open new window
	if(!is.na(ltc$names.scat[1])){
	x11()
	pairs(ltc$yxz$y,pch = 21,bg=c("green","red")[as.factor(out)],label=ltc$names.scat,
	      main=paste("Multiple Scatterplot (Data = ",deparse(ltc$mc[[3]]),")",sep=""),col.main="blue")
	      }
	invisible()
}
################################################################################




#################################################################
summary.lmeRob=function(output, digits = 3) {
	# DLC 18/12/06
	# - verifier les intituls, ...
	ltc=output$ltc
	mc=ltc$mc
	r=output$ltc$dim$r
	gv=ltc$dim$gv
	# headline
	cat("\n\n---\n\n")
	cat("Linear mixed-effects model fit using Tukey's Biweight (MM-estimator)\n")
	cat("Data:", deparse(ltc$mc[[3]]), "\n\n", sep = " ")
	cat("Robust likelihood:",output$likelihood, "\n\n", sep = " ")
	# random effects
	cat("Random Effects:\n")
	cat(" Formula:", deparse(ltc$mc[[4]]), "\n", sep = " ")
	cat(" Structure: Independant Blocks\n\n")
	for(v in 1:r){
	cat(paste(" Block",paste(v,"=",sep=" "),noquote(ltc$dim$idZ[v]),paste("(",ltc$dim$qv[v],")\n",sep=""),sep=" "))
	cat(paste("  Variance: ",round(output$s[v],digits)," (",
	          if(output$s[v]>0) " " else "-",round(sqrt(abs(output$s[v])),digits),")\n\n",sep=""))
	}
	# fixed effects
	cat("Fixed Effects:\n")
	cat(" Formula:",deparse(ltc$mc[[2]]),"\n")
	matxF=matrix(c(output$alpha,output$SE,output$alpha/output$SE,2*(1-pnorm(abs(output$alpha/output$SE)))),ncol=4)
	dimnames(matxF)=list(paste(" ",dimnames(ltc$YXZ$X)[[2]],sep=""),c("Estimate", "Std. Error", "z-value", "Pr(>|z|)"))
	print(round(matxF,digits=digits))
	# robust weights
	cat("\nRobust weights:\n")
	matxW=matrix(output$w,nrow=1)
	dimnames(matxW)=list("  ",sapply(ltc$dim$idqv[[gv]],function(x)substr(x,nchar(gv)+1,nchar(x))))
	print(round(matxW,digits=digits))
	cat("\n---\n")
	}

print.lmeRob=function(output){
	# DLC 18/12/06
	cat("\nCall:\n", deparse(output$ltc$mc), "\n\n", sep = "")
	}
#################################################################




#################################################################
anova.lmeRob=function(output,digit=3){
	# DLC 18/12/06
        ltc=output$ltc
	mt=output$ltc$mt
	X=output$ltc$YXZ$X2
	# constraint alpha
	if(as.logical(attr(mt,"intercept"))){
	 vX=dimnames(attr(mt,"factor"))[[2]];nvX=length(vX)
	 if(is.null(vX)){
            acstr=NULL
	    cat(paste("Warning:\n-> function anova not available when the intercept is the only fixed effects\n"))
	    }else{
	    acstr=as.list(rep(NA,nvX));names(acstr)=vX
            for(i in 1:length(acstr)){acstr[[i]]=attr(X,"assign")==i}
	    }
	}else{
        acstr=NULL
        cat(paste("Warning:\n-> function anova not available when no intercept in the model\n"))
	}
	# anova
	if(!is.null(acstr)){
	lengtest = length(acstr)
	restest = matrix(0,lengtest,1)
	for (test in 1:lengtest){

	   covtest = cov.cbs.mm.fixed.test(ltc,bdp = 0.5, eff=.95, t1 = NULL, mats =output$mats,
	   eps = 10e-5, maxiter = 1000,init.weight=output$w,acstr,test,likelihood=output$likelihood)
 	   restest[test,1]= covtest$pvalue
  }


  restest=as.data.frame(round(restest,digit))
  restest[,1]=as.character(restest[,1])
  restest[,1][restest[,1]==0]="<0.001"
  cat("\nRobust Likelihood Ratio Test:\n\n")
  dimnames(restest)=list(names(acstr),c("p-value"))
  restest
  }
}
################################################################################

cov.cbs.mm.lrt = function(ltc,bdp = 0.5,eff=0.95, t1 = NULL, mats = NULL,
	eps = 10e-5, maxiter = 1000){

  mmSig = cov.cbs(ltc,bdp = 0.5,t1 = NULL, mats = NULL,
	        eps = 10e-5, maxiter = 1000)


  mmAlpha = cov.cbs.mm.fixed(ltc,bdp = 0.5,eff=0.95,t1 = NULL, mats = mmSig$Siginit,
          eps = 10e-5, maxiter = 1000,init.weight=mmSig$w)


  MM.likelihood = sum(biwt.rho(sqrt(mmAlpha$dis),mmAlpha$c1))

  invisible(return(list(alpha=mmAlpha$alpha,SE.alpha=mmAlpha$SE.alpha,s=mmSig$s,
  w=mmAlpha$w,dis=mmAlpha$dis,ltc=ltc,likelihood=MM.likelihood,mats=mmSig$Siginit,
  c1=mmAlpha$c1)))
}




"cov.cbs" = function(ltc,bdp = 0.5, t1 = NULL, mats = NULL,
	eps = 10e-5, maxiter = 1000){
  ##############################################################################
  data <- ltc$yxz$y
 	xfit <- ltc$yxz$x
	zfit <- ltc$yxz$z
	zlength <- length(zfit)
	lxfit <- length(xfit)
	p <- ncol(data)

	n <- nrow(data)
  ##############################################################################
	# arraying the ZZ' matrices
	##############################################################################
	qarray <- array(data = 0, dim = c(p,p,zlength))
	marray <- qarray
	for(i in 1:zlength) {
		qarray[,  , i] <- zfit[[i]] %*% t(zfit[[i]])
	}
 	##############################################################################
	#  initial constrained estimator
	##############################################################################
	if(is.null(t1) || is.null(mats)) {
		initial <- rogkmiss(data)
		if(is.null(t1))
			t1 <- initial$center
		if(is.null(mats))
			mats <- initial$cov
	}
	w <- initial$w


	inv <- solve(mats)
	##############################################################################
	#  X matrices and XX' matrices
	##############################################################################
	k.temp <- xfit[[1]]
	k <- ncol(k.temp)
  sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
  for(i in 1:n){
			sx <- sx+w[i]*t(xfit[[i]])%*%inv%*%as.vector(data[i,])
			tx <- tx+w[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
			}
	alpha <- solve(tx)%*%sx
	##############################################################################
  #  constants
  ##############################################################################
  c1 = Tbsc(bdp,p)
 	crit <- 100
	iter <- 1
	w1d <- rep(1, n)
	d2 <- rep(0,n)
	w2d <- w1d
	vec <- rep(0,zlength)
	Q <- matrix(0,zlength,zlength)
	##############################################################################
	while((iter <= maxiter) & (crit > eps)) {
		inv <- solve(mats)
 		wt.old <- w1d
		alpha.old <- alpha
		mats.old <- mats
  for(i in 1:n){
    mu <- xfit[[i]]%*%alpha
		d2[i] <- mahalanobis(data[i,],mu,mats)
	}
  d <- sqrt(d2)
  h <- floor((n + p + 1)/2)
	quantile <- h/(n + 1)
	d <- (d * sqrt(qchisq(quantile, p)))/(sort(d)[h])
	w1d <- biwt.wt(d,c1)
	w2d <- d*biwt.psi(d,c1)
	##############################################################################
	sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
  for(i in 1:n){
    sx <- sx + w1d[i]*t(xfit[[i]]) %*%inv%*%as.vector(data[i,  ])
    tx <- tx + w1d[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
	}
	alpha <- solve(tx)%*%sx
	##############################################################################
	for(i in 1:zlength) {
	   marray[,  , i] <- inv %*% qarray[,  , i]
	}
 	for(i in 1:zlength) {
    for(j in 1:zlength) {
      Q[i, j] <- sum(diag(marray[,  , i] %*% marray[
      ,  , j]))
    }
  }
  Qinv <- solve(Q)
 	vec <- vec * 0
	UT <- matrix(0, zlength, n)
  for(i in 1:zlength) {
    for(j in 1:n) {
		  t1 <- xfit[[j]]%*%alpha
		  xc <- as.vector(data[j,  ] - t1)
		  vec[i] <- vec[i] + p*w1d[j] * (t(xc) %*% (inv %*%
		  qarray[,  , i] %*% inv) %*% xc)
		  UT[i, j] <- t(xc) %*% (inv %*% qarray[, , i] %*% inv) %*% xc
		}
	}
  s <- (solve(Q) %*% vec)/sum(w2d)
  mats <- mats * 0
	for(i in 1:zlength) {
	   mats <- mats + (s[i] * qarray[,  , i])
	}
	##############################################################################
	crit1 <- max(abs(alpha - alpha.old))
	crit2 <- max(abs(mats - mats.old))
	crit <- max(crit1, crit2)
  iter <- iter + 1
	}
	##############################################################################
	# standard error for the fixed effect vector (alpha)
	##############################################################################
	e.SE=1.0521
  var.mu.R <- e.SE*mats/n
	S.xiT.xi <- matrix(0,length(alpha),length(alpha))
	S.xiT.Sig.xi <- matrix(0,length(alpha),length(alpha))
	for(i in 1:n){
	   S.xiT.xi = S.xiT.xi+t(xfit[[i]])%*%xfit[[i]]
	   S.xiT.Sig.xi = S.xiT.Sig.xi+n*t(xfit[[i]])%*%var.mu.R%*%xfit[[i]]
	}
	var.alpha.R = solve(S.xiT.xi)%*%S.xiT.Sig.xi%*%solve(S.xiT.xi)
	SE.alpha.R = sqrt(diag(var.alpha.R))
	##############################################################################
	##############################################################################
	invisible(return(list(alpha=alpha,SE.alpha=SE.alpha.R,s=s,w=w1d,dis=d2,ltc=ltc,
  Siginit=mats)))
}




"cov.cbs.mm.fixed" = function(ltc,bdp=0.5,eff = .95, t1 = NULL,
  mats=NULL,eps = 10e-5, maxiter = 1000,init.weight){
  ##############################################################################
  data <- ltc$yxz$y
	xfit <- ltc$yxz$x
	zfit <- ltc$yxz$z
	zlength <- length(zfit)
	lxfit <- length(xfit)
	p <- ncol(data)
	n <- nrow(data)
  ##############################################################################
	# arraying the ZZ' matrices
	##############################################################################
	qarray <- array(data = 0, dim = c(p,p,zlength))
	marray <- qarray
	for(i in 1:zlength) {
		qarray[,  , i] <- zfit[[i]] %*% t(zfit[[i]])
	}
	##############################################################################
	#  X matrices and XX' matrices
	##############################################################################
	k.temp <- xfit[[1]]
	k <- ncol(k.temp)
  sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
	inv <- solve(mats)
	w=init.weight
  for(i in 1:n){
			sx <- sx+w[i]*t(xfit[[i]])%*%inv%*%as.vector(data[i,])
			tx <- tx+w[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
			}
	alpha <- solve(tx)%*%sx
	##############################################################################
  #  constants
  ##############################################################################
  if(p==2) {c1=5.12}  else  {c1=Tbsc1(eff,p-2)}
  #c1 = Tbsc1(eff,p-2)
  #c1=5.12
  crit <- 100
	iter <- 1
	w1d <- rep(1, n)
	d2 <- rep(0,n)
	w2d <- w1d
	vec <- rep(0,zlength)
	Q <- matrix(0,zlength,zlength)
	##############################################################################
	while((iter <= maxiter) & (crit > eps)) {
	inv <- solve(mats)
	wt.old <- w1d
	alpha.old <- alpha
	mats.old <- mats
  for(i in 1:n){
    mu <- xfit[[i]]%*%alpha
    d2[i] <- mahalanobis(data[i,],mu,mats)
  }
  d <- sqrt(d2)
  h <- floor((n + p + 1)/2)
	quantile <- h/(n + 1)
	d <- (d * sqrt(qchisq(quantile, p)))/(sort(d)[h])
	w1d <- biwt.wt(d,c1)
	w2d <- d*biwt.psi(d,c1)
	##############################################################################
	sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
  for(i in 1:n){
    sx <- sx + w1d[i]*t(xfit[[i]]) %*%inv%*%as.vector(data[i,  ])
    tx <- tx + w1d[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
	}
	alpha <- solve(tx)%*%sx
  mats <- mats
	##############################################################################
	crit1 <- max(abs(alpha - alpha.old))
	crit2 <- max(abs(mats - mats.old))
	crit <- max(crit1, crit2)
  iter <- iter + 1
	}
	##############################################################################
	# standard error for the fixed effect vector (alpha)
	##############################################################################
	e.SE=1.0521
  var.mu.R <- e.SE*mats/n
	S.xiT.xi <- matrix(0,length(alpha),length(alpha))
	S.xiT.Sig.xi <- matrix(0,length(alpha),length(alpha))
	for(i in 1:n){
	   S.xiT.xi = S.xiT.xi+t(xfit[[i]])%*%xfit[[i]]
	   S.xiT.Sig.xi = S.xiT.Sig.xi+n*t(xfit[[i]])%*%var.mu.R%*%xfit[[i]]
	}
	var.alpha.R = solve(S.xiT.xi)%*%S.xiT.Sig.xi%*%solve(S.xiT.xi)
	SE.alpha.R = sqrt(diag(var.alpha.R))

	##############################################################################
	##############################################################################
	invisible(return(list(alpha=alpha,SE.alpha=SE.alpha.R,w=w1d,dis=d2,ltc=ltc,
  c1=c1)))
}

"cov.cbs.mm.fixed.test" = function(ltc,bdp=0.5,eff =.95, t1 = NULL,
  mats=NULL,eps = 10e-5, maxiter = 1000,init.weight,acstr,test,likelihood){
  ##############################################################################
  SE=c(1,1.5204,1.3920,1.2706,1.1994,1.1515,1.1164,1.0933,1.0739,1.0610)
  data <- ltc$yxz$y
	xfit <- ltc$yxz$x
	zfit <- ltc$yxz$z
	zlength <- length(zfit)
	lxfit <- length(xfit)
	p <- ncol(data)
	n <- nrow(data)
  ##############################################################################
	# arraying the ZZ' matrices
	##############################################################################
	qarray <- array(data = 0, dim = c(p,p,zlength))
	marray <- qarray
	for(i in 1:zlength) {
		qarray[,  , i] <- zfit[[i]] %*% t(zfit[[i]])
	}
	##############################################################################
	#  X matrices and XX' matrices
	##############################################################################
	k.temp <- xfit[[1]]
	k <- ncol(k.temp)
  sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
	inv <- solve(mats)
	w=init.weight
  for(i in 1:n){
			sx <- sx+w[i]*t(xfit[[i]])%*%inv%*%as.vector(data[i,])
			tx <- tx+w[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
			}
	alpha <- solve(tx)%*%sx
	##############################################################################
  #  constants
  ##############################################################################
  if(p==2) {c1=5.12}  else  {c1=Tbsc1(eff,p-2)}
  #c1 = Tbsc1(eff,p-2)
  #c1=5.12
 	crit <- 100
	iter <- 1
	w1d <- rep(1, n)
	d2 <- rep(0,n)
	w2d <- w1d
	vec <- rep(0,zlength)
	Q <- matrix(0,zlength,zlength)
	##############################################################################
	while((iter <= maxiter) & (crit > eps)) {
	inv <- solve(mats)
	wt.old <- w1d
	alpha.old <- alpha
	mats.old <- mats
  for(i in 1:n){
    mu <- xfit[[i]]%*%alpha
    d2[i] <- mahalanobis(data[i,],mu,mats)
  }
  d <- sqrt(d2)
  h <- floor((n + p + 1)/2)
	quantile <- h/(n + 1)
	d <- (d * sqrt(qchisq(quantile, p)))/(sort(d)[h])
	w1d <- biwt.wt(d,c1)
	w2d <- d*biwt.psi(d,c1)
	##############################################################################
	sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
  for(i in 1:n){
    sx <- sx + w1d[i]*t(xfit[[i]]) %*%inv%*%as.vector(data[i,  ])
    tx <- tx + w1d[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
	}
	alpha <- solve(tx)%*%sx
	alpha.c = unlist(acstr[test])
	alpha.c = alpha.c==FALSE
	alpha=alpha*alpha.c
  mats <- mats
	##############################################################################
	crit1 <- max(abs(alpha - alpha.old))
	crit2 <- max(abs(mats - mats.old))
	crit <- max(crit1, crit2)
  iter <- iter + 1
	}
	##############################################################################
	# standard error for the fixed effect vector (alpha)
	##############################################################################
	e.SE=1.0521
  var.mu.R <- e.SE*mats/n
	S.xiT.xi <- matrix(0,length(alpha),length(alpha))
	S.xiT.Sig.xi <- matrix(0,length(alpha),length(alpha))
	for(i in 1:n){
	   S.xiT.xi = S.xiT.xi+t(xfit[[i]])%*%xfit[[i]]
	   S.xiT.Sig.xi = S.xiT.Sig.xi+n*t(xfit[[i]])%*%var.mu.R%*%xfit[[i]]
	}
	var.alpha.R = solve(S.xiT.xi)%*%S.xiT.Sig.xi%*%solve(S.xiT.xi)
	SE.alpha.R = sqrt(diag(var.alpha.R))
	##############################################################################
  # M and Q matrices
  ##############################################################################

  alpha.zero=rep(0,length(alpha))
 	alpha.nozero=alpha[alpha!=0]
 	alpha.zero[1:length(alpha.nozero)]=alpha.nozero
 	alpha =alpha.zero

 	vecQ <- rep(0,length(alpha))
	vecM <- rep(0,length(alpha))
	vecpsi <- rep(0,length(alpha))
	Q <- matrix(0,length(alpha),length(alpha))
	M <- matrix(0,length(alpha),length(alpha))

	for(i in 1:n){
		vecq <- as.vector(w1d[i]*(t(xfit[[i]])%*%xfit[[i]]%*%alpha-t(xfit[[i]])%*%data[i,]))
		vecm <- as.vector(t(xfit[[i]])%*%xfit[[i]]%*%alpha-t(xfit[[i]])%*%data[i,])
		Q <- Q + vecq%*%t(vecq)
		M <- M + vecq%*%t(vecm)
		vecpsi <- vecpsi+vecq
	}
	M <- M/n
	Q <- Q/n

  ##############################################################################
  # M* and Q[M-M*] matrices + eigenvalues lambda
  ##############################################################################
  l1 = length(alpha.nozero)

	Mstar <- matrix(0,length(alpha),length(alpha))
	Mstar[1:l1,1:l1] <- solve(M[1:l1,1:l1])
  Eigen.M <- Q%*%(solve(M)-Mstar)
  lambda.eigen <- eigen(Eigen.M)$values
  options(warn=-1)
  lambda.eigen <- as.double(lambda.eigen)
  lambda.eigen <- na.omit(lambda.eigen[lambda.eigen>10e-5])
  options(warn=0)
  ##############################################################################
  # Compute LRT test and p-value
	##############################################################################
	MM.rho.sum.uncons = likelihood
	MM.rho.sum.cons = sum(biwt.rho(sqrt(d2),c1))
	lrt.test = (-2)*(MM.rho.sum.uncons-MM.rho.sum.cons)
	pvalue.lrt = wood.pvalue(lambda.eigen,lrt.test)
	invisible(return(list(pvalue=pvalue.lrt)))
}



"gnan0" = function(x, c1,c2)
{
	d <- apply(x, 2, mad)
	w <- sweep(x, 2, apply(x, 2, median), FUN = "-")
	w.c <- sweep(w, 2, d, FUN = "/")
	I <- ifelse(abs(w.c) <= c1, 1, 0)
	wc <- (1 - (w.c/c1)^2)^2 * I
	vec.mu <- apply(x * wc, 2, sum)/apply(wc, 2, sum)
	mat <- sweep(x, 2, vec.mu, FUN = "-")
	mat.c <- sweep(mat, 2, d, FUN = "/")
	rhoc <- ifelse(mat.c^2 <= c2^2, mat.c^2, c2^2)
	sig2 <- apply(rhoc, 2, mean) * d^2
	return(list(vec.mu=vec.mu,sig2=sig2))
}



"rogkmiss" = function(data, c1 = 4.5, c2 = 3){
	#
	# variables declaration
	#
	n <- nrow(data)
	p <- ncol(data)
	D <- matrix(0, p, p)
	M <- matrix(0, p, p)
	U <- matrix(0, p, p)
	k <- ((p - 1) * p)/2
	yp <- rep(0, n)
	ym <- rep(0, n)
	#
	# compute matrice D and standardized observations y
	#
        D.start <- gnan0(data, c1, c2)
	D.diag <- sqrt(D.start$sig2)
	y <- sweep(data, 2, D.diag, FUN = "/")
	diag(D) <- D.diag
	#
	# compute matrix U, eigenvectors and eigenvalues
	#
	i <- 1
	while(i <= p - 1) {
		j <- i + 1
		while(j <= p) {
			yp <- cbind(yp, y[, i] + y[, j], deparse.level = 1)
			ym <- cbind(ym, y[, i] - y[, j], deparse.level = 1)
			j <- j + 1
		}
		i = i + 1
	}
	y.plus <- yp[, 2:(k + 1)]
	y.moins <- ym[, 2:(k + 1)]
	d.plus <- apply(y.plus, 2, mad, na.rm = T)
	w <- sweep(y.plus, 2, apply(y.plus, 2, median, na.rm = T), FUN = "-")
	w.plus <- sweep(w, 2, d.plus, FUN = "/")
	I.plus <- ifelse(abs(w.plus) <= c1, 1, 0)
	wc.plus <- (1 - (w.plus/c1)^2)^2 * I.plus
	vec.mu.plus <- apply(y.plus * wc.plus, 2, sum, na.rm = T)/apply(wc.plus, 2, sum, na.rm = T)
	mat <- sweep(y.plus, 2, vec.mu.plus, FUN = "-")
	mat.plus <- sweep(mat, 2, d.plus, FUN = "/")
	rhoc.plus <- ifelse(mat.plus^2 <= c2^2, mat.plus^2, c2^2)
	sig2.plus <- apply(rhoc.plus, 2, mean, na.rm = T) * (d.plus^2)
	d.moins <- apply(y.moins, 2, mad, na.rm = T)
	w <- sweep(y.moins, 2, apply(y.moins, 2, median, na.rm = T), FUN = "-")
	w.moins <- sweep(w, 2, d.moins, FUN = "/")
	I.moins <- ifelse(abs(w.moins) <= c1, 1, 0)
	wc.moins <- (1 - (w.moins/c1)^2)^2 * I.moins
	vec.mu.moins <- apply(y.moins * wc.moins, 2, sum, na.rm = T)/apply(wc.moins, 2, sum, na.rm = T)
	mat <- sweep(y.moins, 2, vec.mu.moins, FUN = "-")
	mat.moins <- sweep(mat, 2, d.moins, FUN = "/")
	rhoc.moins <- ifelse(mat.moins^2 <= c2^2, mat.moins^2, c2^2)
	sig2.moins <- apply(rhoc.moins, 2, mean, na.rm = T) * (d.moins^2)
	vec.U <- 0.25 * (sig2.plus - sig2.moins)
	iter <- 0
	start <- 1
	vec.start <- p:1
	vec.end <- (p - 1):2
	for(i in 2:p) {
		iter <- iter + 1
		end <- sum((p - 1):vec.start[i])
		U[iter, i:p] <- vec.U[start:end]
		start <- start + vec.end[iter]
	}
	U <- U + t(U)
	diag(U) <- 1
	eig <- eigen(U)
	e <- eig$values
	E <- eig$vectors
	#
	# compute V(X) and t(X)
	#
	Z <- y %*% E
	A <- D %*% E
	Z.final <- gnan0(Z, c1, c2)
	diag(M) <- Z.final$sig2
	mu <- Z.final$vec.mu
	V <- A %*% M %*% t(A)
	t <- A %*% mu
	####################################################3
	mal <- mahalanobis(data, t, V)
	qmal <- median(mal)
	qup <- qchisq(0.9, p)
	qdown <- qchisq(0.5, p)
	do <- (qup * qmal)/qdown
	w <- ifelse(mal <= do, 1, 0)
	#	rwdata <- sweep(data, 1, w, FUN = "*")
	#	tw <- apply(rwdata, 2, sum)/sum(w)
	#	mats <- matrix(0, p, p)
	#	for(i in 1:n) {
	#		xc <- as.vector(data[i,  ] - tw)
	#		mats <- mats + as.numeric(w[i]) * (xc %o% xc)
	#	}
	#	V <- mats/sum(w)
		return(list(center = t, cov = V,w=w))
	}







################################################################################

"cov.mle" = function(ltc,bdp = 0.5, arp = 0.01, t1 = NULL, mats = NULL,
	eps = 10e-5, maxiter = 1000){
  ##############################################################################
  data <- ltc$yxz$y
	xfit <- ltc$yxz$x
	zfit <- ltc$yxz$z
	zlength <- length(zfit)
	lxfit <- length(xfit)
	p <- ncol(data)
	n <- nrow(data)
  ##############################################################################
	# arraying the ZZ' matrices
	##############################################################################
	qarray <- array(data = 0, dim = c(p,p,zlength))
	marray <- qarray
	for(i in 1:zlength) {
		qarray[,  , i] <- zfit[[i]] %*% t(zfit[[i]])
	}
 	##############################################################################
	#  initial estimator
	##############################################################################
	t1 <- apply(data,2,mean)
	mats <- var(data)
	inv <- solve(mats)
	##############################################################################
	#  X matrices and XX' matrices
	##############################################################################
	w=rep(1,n)
  k.temp <- xfit[[1]]
	k <- ncol(k.temp)
  sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
  for(i in 1:n){
			sx <- sx+w[i]*t(xfit[[i]])%*%inv%*%as.vector(data[i,])
			tx <- tx+w[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
			}
	alpha <- solve(tx)%*%sx
	##############################################################################
  #  constants for the S estimator
  ##############################################################################
 	crit <- 100
	iter <- 1
	w1d <- rep(1, n)
	d2 <- rep(0,n)
	w2d <- w1d
	vec <- rep(0,zlength)
	Q <- matrix(0,zlength,zlength)
	##############################################################################
	while((iter <= maxiter) & (crit > eps)) {
		inv <- solve(mats)
 		wt.old <- w1d
		alpha.old <- alpha
		mats.old <- mats
  for(i in 1:n){
    mu <- xfit[[i]]%*%alpha
		d2[i] <- mahalanobis(data[i,],mu,mats)
	}
  d <- sqrt(d2)
	w1d <- rep(1,n)
	w2d <- rep(1,n)
	##############################################################################
	sx <- matrix(0,k,1)
	tx <- matrix(0,k,k)
  for(i in 1:n){
    sx <- sx + w1d[i]*t(xfit[[i]]) %*%inv%*%as.vector(data[i,  ])
    tx <- tx + w1d[i]*t(xfit[[i]])%*%inv%*%xfit[[i]]
	}
	alpha <- solve(tx)%*%sx
	##############################################################################
	for(i in 1:zlength) {
	   marray[,  , i] <- inv %*% qarray[,  , i]
	}
 	for(i in 1:zlength) {
    for(j in 1:zlength) {
      Q[i, j] <- sum(diag(marray[,  , i] %*% marray[
      ,  , j]))
    }
  }
  Qinv <- solve(Q)
 	vec <- vec * 0
	UT <- matrix(0, zlength, n)
  for(i in 1:zlength) {
    for(j in 1:n) {
		  t1 <- xfit[[j]]%*%alpha
		  xc <- as.vector(data[j,  ] - t1)
		  vec[i] <- vec[i] + p*w1d[j] * (t(xc) %*% (inv %*%
		  qarray[,  , i] %*% inv) %*% xc)
		  UT[i, j] <- t(xc) %*% (inv %*% qarray[, , i] %*% inv) %*% xc
		}
	}
  s <- (solve(Q) %*% vec)/(sum(w2d)-1)
  mats <- mats * 0
	for(i in 1:zlength) {
	   mats <- mats + (s[i] * qarray[,  , i])
	}
	##############################################################################
	crit1 <- max(abs(alpha - alpha.old))
	crit2 <- max(abs(mats - mats.old))
	crit <- max(crit1, crit2)
  iter <- iter + 1
	}
	##############################################################################
	# standard error for the fixed effect vector (alpha)
	##############################################################################
	e.SE=1
  var.mu.R <- e.SE*mats/n
	S.xiT.xi <- matrix(0,length(alpha),length(alpha))
	S.xiT.Sig.xi <- matrix(0,length(alpha),length(alpha))
	for(i in 1:n){
	   S.xiT.xi = S.xiT.xi+t(xfit[[i]])%*%xfit[[i]]
	   S.xiT.Sig.xi = S.xiT.Sig.xi+n*t(xfit[[i]])%*%var.mu.R%*%xfit[[i]]
	}
	var.alpha.R = solve(S.xiT.xi)%*%S.xiT.Sig.xi%*%solve(S.xiT.xi)
	SE.alpha.R = sqrt(diag(var.alpha.R))
	##############################################################################
	##############################################################################
	invisible(return(list(alpha=alpha,SE.alpha=SE.alpha.R,s=s,w=w1d,dis=d2,ltc=ltc)) )
}

Tbsc <- function(bdp,p,maxit = 1e3,eps = 1e-8,diff = 1e6)
{
# constant for sfirst Tukey Biweight rho-function for MM, for fixed
# breakdown point
  talpha = sqrt(qchisq(1-bdp,p))
  ctest = talpha
  iter = 1
  while ((diff>eps)*(iter<maxit))
  {
    cold = ctest
    ctest = Tbsb(cold,p)/bdp
    diff = abs(cold-ctest)
    iter = iter+1
  }
  return(ctest)
}
################################################################################
Tbsc1 <- function(eff,p)
{# constant for second Tukey Biweight rho-function for MM, for fixed shape-efficiency
#
# Direct cals: sigma1, Tbsc

maxit <- 1000
eps <- 10^(-8)
diff <- 10^6
ctest <- Tbsc(0.5,p)
iter <- 1
while ((diff>eps) & (iter<maxit)){
    cold <- ctest
    ctest <- cold*eff*sigma1(cold,p)
    diff <- abs(cold-ctest)
    iter <- iter+1

}
return(ctest)
}

################################################################################
gint<-function(k,c,p)
{
# this procedures computes the integral from zero to c of
# the function r^k g(r^2), where g(||x||^2) is the density function
# of a p-dimensional standardnormal distribution
#
# Direct calls: none
e<-(k-p-1)/2
numerator<-(2^e)*pgamma((c^2)/2,(k+1)/2)*gamma((k+1)/2)
res<-(numerator/(pi^(p/2)))
return(res)
}


################################################################################
sigma1<-function(c,p)
# Direct calls: gint
{
Cp <- 2*(pi^(p/2))/gamma(p/2)
gamma1.1 <- gint(p+1,c,p) - 6*gint(p+3,c,p)/(c^2) + 5*gint(p+5,c,p)/(c^4)
gamma1.2 <- gint(p+1,c,p) - 2*gint(p+3,c,p)/(c^2) + gint(p+5,c,p)/(c^4)
gamma1 <- Cp * ( gamma1.1 + (p+1)*gamma1.2 ) / (p+2)

s1 <- Cp * ( gint(p+3,c,p) - 4*gint(p+5,c,p)/(c^2) + 6*gint(p+7,c,p)/(c^4) -
 4*gint(p+9,c,p)/(c^6) + gint(p+11,c,p)/(c^8) ) /gamma1^2 * p/(p+2)
return(s1)
}
################################################################################

#
Tbsb <- function(c,p)
{
  y1 = ksiint(c,1,p)*3/c-ksiint(c,2,p)*3/(c^3)+ksiint(c,3,p)/(c^5)
  y2 = c*(1-pchisq(c^2,p))
  return(y1+y2)
}
################################################################################

ksiint <- function(c,s,p) {(2^s)*gamma(s+p/2)*pgamma(c^2/2,s+p/2)/gamma(p/2)}

 Tbsb <- function(c,p)
{
  y1 = ksiint(c,1,p)*3/c-ksiint(c,2,p)*3/(c^3)+ksiint(c,3,p)/(c^5)
  y2 = c*(1-pchisq(c^2,p))
  return(y1+y2)
}
################################################################################
biwt.rho<- function(x,c)
{
  hulp = x^2/2-x^4/(2*c^2)+x^6/(6*c^4);
  rho = hulp*(abs(x)<c)+c^2/6*(abs(x)>=c)
  rho
}

################################################################################
biwt.wt <- function(e,k){
    ifelse (abs(e) <= k,(1 - (e/k)^2)^2,0)
}
################################################################################
biwt.psi <- function(e,k){
    ifelse (abs(e) <= k, e*(1 - (e/k)^2)^2,0)
}
################################################################################



wood.pvalue=function (coef, f, tol = 0, print = FALSE)
{
    if (min(coef) < 0)
        stop("negative eigenvalues")
    if (length(coef) == 1) {
        pval <- 1 - pchisq(f/coef, 1)
    }
    else {
        k1 <- sum(coef)
        k2 <- 2 * sum(coef^2)
        k3 <- 8 * sum(coef^3)
        t1 <- 4 * k1 * k2^2 + k3 * (k2 - k1^2)
        t2 <- k1 * k3 - 2 * k2^2
        if ((t2 <= tol) && (tol < t2)) {
            a1 <- k1^2/k2
            b <- k1/k2
            pval <- 1 - pgamma(b * f, a1)
            if (print)
                print(paste("Satterthwaite-Welsh Approximation =",
                  pval))
        }
        else if ((t1 <= tol) && (tol < t2)) {
            a1 <- 2 + (k1/k2)^2
            b <- (k1 * (k1^2 + k2))/k2
            pval <- if (f < tol)
                1
            else 1 - pgamma(b/f, a1)
            if (print)
                print(paste("Inverse gamma approximation =",
                  pval))
        }
        else if ((t1 > tol) && (t2 > tol)) {
            a1 <- (2 * k1 * (k1 * k3 + k2 * k1^2 - k2^2))/t1
            b <- t1/t2
            a2 <- 3 + 2 * k2 * (k2 + k1^2)/t2
            pval <- 1 - pbeta(f/(f + b), a1, a2)
            if (print)
                print(paste("Three parameter F(Pearson Type VI) approximation=",
                  pval))
        }
        else {
            pval <- -1
            if (print)
                print("Wood's Approximation failed")
        }
    }
    pval
}

denman.beavers <- function(mat,maxit=50) {
  stopifnot(nrow(mat) == ncol(mat))
  niter <- 0
  y <- mat
  z <- diag(rep(1,nrow(mat)))
  for (niter in 1:maxit) {
    y.temp <- 0.5*(y+solve(z))
    z <- 0.5*(z+solve(y))
    y <- y.temp
  }
  return(list(sqrt=y,sqrt.inv=z))
}


Norm.TM=function(cc){
    norm.trunc.mom=function(mom,cc,Lm2){drop(-cc^(mom-1)*dnorm(cc)+(mom-1)*pnorm(cc)*Lm2)}
    norm.mom=function(mom){drop(factorial(mom)/(2^(mom/2)*factorial(mom/2)))}
    #
    L0=pnorm(-cc)
    L2=norm.trunc.mom(2,-cc,L0)
    L4=norm.trunc.mom(4,-cc,L2)
    L6=norm.trunc.mom(6,-cc,L4)
    L8=norm.trunc.mom(8,-cc,L6)
    L10=norm.trunc.mom(10,-cc,L8)
    L12=norm.trunc.mom(12,-cc,L10)
    L14=norm.trunc.mom(14,-cc,L12)
    #
    int.0=1-2*pnorm(-cc)
    int.2=norm.mom(2)-2*L2
    int.4=norm.mom(4)-2*L4
    int.6=norm.mom(6)-2*L6
    int.8=norm.mom(8)-2*L8
    int.10=norm.mom(10)-2*L10
    int.12=norm.mom(12)-2*L12
    int.14=norm.mom(14)-2*L14
    # out
    drop(c(int.0,int.2,int.4,int.6,int.8,int.10,int.12,int.14))
    }


